minor fixes and documentation
[automated-distro-installer] / faiserver-setup
index 724a09c7bce7e4182dd9d01658cb7169e9102f28..3db726547136c4fba7d636c1a8097c72c18c5a1c 100755 (executable)
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 
+# Usage: faiserver-setup
+#
 # Initial setup of a fai server on debian. works on localhost.
 # Set's the current ip as the tftp server. I vaguely remember
-# that using a hostname does not work
-# Requires changing dns to point faiserver and running fai-redep
+# that using a hostname does not work.
+# Separate from running this, faiserver needs to be setup in dns
+# to point to whatever host this is run on.
 
 set -eE -o pipefail
 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
@@ -27,17 +30,24 @@ trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
 e() { echo "$@"; "$@"; }
 
-base=${1:-jessie}
+# When stretch becomes stable, change this to stretch.
+# I've tested this with stretch, it works, but notably,
+# the automatic basefile getting will be for stretch
+# instead of jessie, so if you install jessie, you need
+# to setup the basefile and it's corresponding class.
+base=jessie
 sed="sed -ri --follow-symlinks"
 
-
-if [[ $base == jessie ]]; then
+if grep -xFq 'VERSION="9 (stretch)"' /etc/os-release; then
+  # if we use stretch, no need for fai-project repo.
+  # this will need to be updated when there is a codename
+  # for stretch+1
+  rm -f /etc/apt/sources.list.d/fai.list
+else
     wget -O - http://fai-project.org/download/074BCDE4.asc | apt-key add -
     cat >/etc/apt/sources.list.d/fai.list <<'EOF'
 deb http://fai-project.org/download jessie koeln
 EOF
-else
-    rm -f /etc/apt/sources.list.d/fai.list
 fi
 
 # for ubuntu:
@@ -45,35 +55,41 @@ fi
 
 # for debian:
 
+
 apt-get update
-# all the dependencies except the dhcp server
-deps="$(apt-cache show fai-quickstart | grep ^Depends: |head -n 1|\
-              sed -r 's/^Depends:|,|\|[^,]+|isc-dhcp-server//g')"
-to_install=()
-for pkg in $deps; do
-    dpkg -s $pkg &>/dev/null && continue ||:
-    to_install+=($pkg)
-    # just so we have a record.
-    echo `date` $pkg >>/var/log/fai-manually-installed-packages.log
-done
-if [[ $to_install ]]; then
-    apt-get -y install ${to_install[@]}
-fi
+
+# Relevant packages from fai-quickstart depends and fai-server recommends.
+# I especially do not wait isc-dhcp-server or an inetd
+apt-get install -y fai-doc nfs-kernel-server tftpd-hpa tar reprepro squashfs-tools binutils
+apt-get install --no-install-recommends -y fai-server
 
 r=http://http.us.debian.org/debian
-# like default, but scrap httpredir and add suggested newer pkgs in fai-project.org
+# like default, but scrap httpredir, and nonfree.
+# All my systems should be able to get along without nonfree
+# for a base working system afaik.
 dd of=/etc/fai/apt/sources.list <<EOF
-deb $r $base main contrib non-free
-deb http://security.debian.org/debian-security $base/updates main contrib non-free
-
+deb $r $base main contrib
+deb http://security.debian.org/debian-security $base/updates main contrib
 EOF
 
 if [[ $base == jessie ]]; then
-    tee -a /etc/fai/apt/sources.list <<'EOF'
+  tee -a /etc/fai/apt/sources.list <<'EOF'
+# uncommenting this from the defaults. it's got bug fixes.
+# repository that may contain newer fai packages for jessie
 deb http://fai-project.org/download jessie koeln
+# fix tar https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=819978
+deb http://ftp.debian.org/debian jessie-backports main
+EOF
+
+  # note, fai doesn't look at /etc/fai/apt/preferences.d
+  cat >/etc/fai/apt/preferences <<'EOF'
+Package: tar
+Pin: release a=jessie-backports
+Pin-Priority: 500
 EOF
 fi
 
+
 # tried out a stretch base, doesn't work yet.
 $sed -f - /etc/fai/nfsroot.conf <<EOF
 s,^( *FAI_DEBOOTSTRAP=).*,\1"$base $r",
@@ -85,18 +101,12 @@ $sed 's/#LOGUSER/LOGUSER/' /etc/fai/fai.conf
 
 
 if ! grep cryptsetup /etc/fai/NFSROOT &>/dev/null; then
-    $sed '/^PACKAGES install$/a cryptsetup' /etc/fai/NFSROOT
+  $sed '/^PACKAGES install$/a cryptsetup' /etc/fai/NFSROOT
 fi
 e fai-setup -vf
 { head -n 1 /srv/fai/nfsroot/root/.ssh/known_hosts | awk '{print $1}' \
-      | tr '\n' ' '; ssh-keyscan localhost | grep -o "ecdsa-sha2-nistp256.*"; \
-    } >>/srv/fai/nfsroot/root/.ssh/known_hosts
-
-# this does not alter the config on a new install
-$sed 's#^([[:space:]]*TFTP_DIRECTORY[[:space:]]*=).*#\1"/srv/tftp"#' \
-     /etc/default/tftpd-hpa
-
-service tftpd-hpa restart
+    | tr '\n' ' '; ssh-keyscan localhost | grep -o "ecdsa-sha2-nistp256.*"; \
+  } >>/srv/fai/nfsroot/root/.ssh/known_hosts
 
 # initially did the basic fai-chboot -Iv $std_arg default
 # but found in console that it wanted to mount nfsroot
@@ -108,17 +118,6 @@ service tftpd-hpa restart
 
 # Add debug to -f flag for more verbose output.
 
-std_arg="-u nfs://faiserver/srv/fai/config"
-e fai-chboot -Iv $std_arg default # reset so we are idempotent
-kernel=$(fai-chboot -L '^default$' | awk '{print $3}')
-type -t host &>/dev/null || apt-get -y install dnsutils
-# resolve host using gateway address
-my_ip=$(host faiserver $(route -n | sed -rn 's/^(0\.){3}0\s+(\S+).*/\2/p') | \
-            sed -rn 's/^\S+ has address //p')
-k_args=$(fai-chboot -L '^default$' | \
-             sed -r "s/^(\S+\s+){3}(.*root=)(.*)/\2$my_ip:\3/")
-e fai-chboot -k "$k_args" -v -f verbose,sshd,createvt,reboot $std_arg $kernel default
-
 # make the faiserver also the apt proxy server
 apt-get -y install apt-cacher-ng